%{
/*
 * cvt_mailrc
 *
 *	This program is used to convert .mailrc mail configuration file to
 *      .mailalias NeXTMail configuration files.
 * 
 * Copyright (C) 1991 Roberto Di Cosmo
 *
 * Everyone is granted permission to copy, modify and redistribute
 * this file, as far as this notice is preserved on all copies.
 *
 * Written by:
 *      Roberto Di Cosmo <dicosmo@dmi.ens.fr>
 *      Dipartimento di Informatica     LIENS
 *      Universita' di Pisa             Ecole Normale Superieure
 *      Corso Italia, 40                45, Rue d'Ulm
 *      Pisa ITALY                      Paris FRANCE
 *
 */
char    *aliasname = "";
char    *groupbody = "";
char    *aliasbody = "";
char    *aliases   = "";
char    *tmp       = "";
%}

S       [ \t]+

%Start Nrm AliasName AliasBody GroupRest

%%
<Nrm>"alias"[ \t]+     {BEGIN AliasName;}
<Nrm>.                 {/* Ignore other mail commands */;}
<Nrm>[\n]               ;

<AliasName>[^\t\n ,]+  {strcpy(aliasname,yytext);
                         BEGIN AliasBody;}
<AliasName>.           {printf("******* Error in conversion ... incorrect alias\n");}

<AliasBody>{S}         ;
<AliasBody>[^\t\n ,]+[\t ]*$ {strcpy(aliasbody, yytext); committalias(); BEGIN Nrm;}
<AliasBody>[^\t\n ,]+[, \t]  {strcat(groupbody, yytext); BEGIN GroupRest;}

<GroupRest>[^\t\n ,]+[\t ]*$ {strcat(groupbody, yytext); committgroup(); BEGIN Nrm;}
<GroupRest>[^\t\n ,]+[,]     {strcat(groupbody, yytext);}
<GroupRest>[^\t\n ,]+[ \t]   {strcat(groupbody, ", "); strcat(groupbody, yytext);}


%%

committgroup()
{
printf("%s: %s\n", aliasname, groupbody);
resetvars();
}

committalias()
{
sprintf(tmp, "%s <%s>, ", aliasname, aliasbody); 
strcat(aliases, tmp);
resetvars();
}

/*
 * this is the *REAL* conversion loop, that is exported...
 */

void cvt_mailrc()
{
        allocfields();
        BEGIN Nrm;
        while (yylex()) {};
        printf("Private Users: %s\n", aliases);
}

allocfields()
{       /* allocate memory for parser varibles */
        tmp       = malloc(6000);
        aliasname = malloc(80);
        aliasbody = malloc(1000);
        groupbody = malloc(5000);
        aliases   = malloc(50000); /* contains *ALL* the group aliases!!!!! */ 
}

resetvars()
{
        (void)strcpy(aliasname, "" );   
        (void)strcpy(aliasbody, "" );
        (void)strcpy(groupbody, "" );
}
