/* -*-C-*-
*******************************************************************************
*
* File:         nextmail.m
* RCS:          $Header: /usr/local/lib/cvs/mailapp-utilities/nextmail.m,v 1.3 1994/11/03 04:36:24 cedman Exp $
* Description:  A 'mail' compatible program to open a Mail.app Compose window
* Author:       Carl Edman
* Created:      Thu Mar  4 13:42:52 1993
* Modified:     Mon Oct 24 17:56:32 1994 (Carl Edman) cedman@freedom.princeton.edu
* Language:     Objective C
* Package:      mailapp-utilities
* Status:       First release
*
* (C) Copyright 1993, but otherwise this file is perfect freeware.
*
*******************************************************************************
*/

#import <appkit/appkit.h>
#import <stdlib.h>
#import <stdio.h>
#import "MailSpeaker.h"
#import "mailutil.h"

void main(int ac,char *av[])
   {
   id 		speaker;
   port_t 	mailPort;
   int window;
   char *to=0,*subject=0,*cc=0,*content=0;
   int tolen=0,subjectlen=0,cclen=0,contentlen=0;
   int tomaxlen=0,subjectmaxlen=0,ccmaxlen=0,contentmaxlen=0;
   int errflg=0,editflg=0,c,i;

   while((c=getopt(ac,av,"s:c:e"))!=EOF) switch(c)
      {
    case 's':
      if (subject) appstring(&subject,&subjectlen,&subjectmaxlen," ",1);
      appstring(&subject,&subjectlen,&subjectmaxlen,optarg,strlen(optarg));
      break;
    case 'c':
      if (cc) appstring(&cc,&cclen,&ccmaxlen,",",1);
      appstring(&cc,&cclen,&ccmaxlen,optarg,strlen(optarg));
    case 'e':
      editflg++;
      break;
    case '?':
    default:
      errflg++;
      break;
      }

   for(;optind<ac;optind++)
      {
      if (to) appstring(&to,&tolen,&tomaxlen,",",1);
      appstring(&to,&tolen,&tomaxlen,av[optind],strlen(av[optind]));
      }

   if (errflg)
      {
      fprintf(stderr,"Usage: %s [-i] [-e] [-s subject] [-c user] [user...]\n",av[0]);
      exit(1);
      }
      while((i=fread(growstring(&content,&contentlen,&contentmaxlen,LINELEN*16),
                     1,16*LINELEN,stdin))>0)
         contentlen+=i;

   speaker = [[MailSpeaker alloc] init];
   mailPort = NXPortFromName("Mail", NULL);
   mailPort = NXPortFromName("MailSendDemo", NULL);

   if (mailPort == PORT_NULL) 
      {
      fprintf(stderr,"Unable to connect to Mail.app\n");
      exit(2);
      }
   
   [speaker setSendPort: mailPort];
   [speaker openSend:&window];
   if (to)
      {
      appstring(&to,&tolen,&tomaxlen,"\0",1);
      [speaker setTo:to inWindow:window];
      }
   if (subject)
      {
      appstring(&subject,&subjectlen,&subjectmaxlen,"\0",1);
      [speaker setSubject:subject inWindow:window];
      }
   if (cc)
      {
      appstring(&cc,&cclen,&ccmaxlen,"\0",1);
      [speaker setCc:cc inWindow:window];
      }
   if (content)
      {
      appstring(&content,&contentlen,&contentmaxlen,"\0",1);
      [speaker setBody:content inWindow:window];
      }
   if ((!editflg) && to) [speaker deliver:window];
   
   [speaker free];
   }

