#!/bin/sh
# @(#)samples/bsmtp/cbsmtp.sh	1.4 03 Nov 1991 02:13:06

# deliver messages accumlated into subdirectories of the
# outq spool directory.  Subdirectory names are based on
# the actual hostnames involved:

LOCALHOST=busboy.uts.amdahl.com
MAXSIZE=100000

OUTQ=/usr/spool/smail/outq
UUX=/usr/bin/uux
COMPRESS=/usr/local/bin/compress

cd $OUTQ || exit 1

# loop through all of the subdirectories
for i in *
do
    (
	# change to directory or exit subshell
	test -d $i || exit
	cd $i || exit 1

	# send multiple batches
	while :
	do
		# get the list of message files; quit if none
		msgs="`ls q* 2>/dev/null`"
		test -n "$msgs" || break

		# accumulate until total size exceeds maximum
		send=
		sz=0
		for f in $msgs
		do
			send="$send $f"
			n=`wc -c <$f 2>/dev/null`
			test -n "$n" || continue
			sz=`expr $sz + $n`
			test $sz -lt $MAXSIZE || break
		done

		# send compressed messages, adding HELO and QUIT commands
		( echo "HELO <$LOCALHOST>"
		  cat $send
		  echo QUIT ) | $COMPRESS | $UUX - $i!rsmtp

		# remove messages that were sent
		rm $send
	done
    )
done

exit 0
