/* @(#)util/dbm_compat.h	1.3 09 Dec 1991 01:37:41 */

/*
 * dbm_compat.h:
 *	Low-functionality compatibility header for dbm and ndbm.
 */

#undef NULL		/* dbm.h often defines NULL */

#ifdef HAVE_NDBM

#include <ndbm.h>
static DBM *db;
#define dbminit(f) \
  ((db = dbm_open((f),2,0)) ? 0 : (db = dbm_open((f),0,0)) ? 0 : -1)
#define dbmclose()  ((db ? (dbm_close(db),0) : 0), db = (DBM *)NULL, 0)
#define store(k,v)  dbm_store(db,k,v,DBM_INSERT)
#define fetch(k)    dbm_fetch(db,k)

#else	/* !HAVE_NDBM */
#ifdef HAVE_DBM

#include <dbm.h>
#define dbmclose()  0

#endif	/* HAVE_DBM */
#endif	/* !HAVE_NDBM */

#undef NULL		/* in case dbm.h does not define NULL */
#define NULL 0

#ifndef HAVE_DBM	/* we now support the old-style dbm functions */
#define HAVE_DBM
#endif
