/*+++*
 *  RCS		$Id: p-errno.h,v 1.1 1993/02/02 21:00:42 gerben Exp $
 *  title:	p-errno.h
 *  abstract:	portable Posix-compliant <errno.h>.
 *  author:	T.R.Hageman, Groningen, The Netherlands
 *  created:	December 1992
 *  modified:	(see RCS Log at end)
 *  copyleft:
 *
 *		Copyright (C) 1992  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  description:
 *
 *	This is a Posix-compatible version of <errno.h> for both Posix
 *	and non-Posix systems.
 *
 *	Notes:
 *	 o  Nothing is guaranteed about the presence of individual errno codes.
 *---*/

#ifndef _P_ERRNO_H_
#define _P_ERRNO_H_	0x100

#ifndef _PORTDEFS_H_
#   include "portdefs.h"
#endif

#include <errno.h>

#if !_ANSI_LIBRARY_
#   ifndef errno
extern int	errno;
#   endif
#endif

#endif /* _P_ERRNO_H_ */
