/*+++*
 *  RCS		$Id: p-grp.h,v 1.2 1993/02/02 21:00:42 gerben Exp $
 *  title:	p-grp.h
 *  abstract:	portable Posix-compliant <grp.h>.
 *  author:	T.R.Hageman, Groningen, The Netherlands
 *  created:	September 1992
 *  modified:	(see RCS Log at end)
 *  copyleft:
 *
 *		Copyright (C) 1992  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  description:
 *
 *	This is a Posix-compatible version of <grp.h> for both Posix
 *	and non-Posix systems.
 *
 *	Notes:
 *---*/

#ifndef _P_GRP_H_
#define _P_GRP_H_	0x100

#ifndef _PORTDEFS_H_ 
#   include "portdefs.h"
#endif

#if __STRICT_ANSI__
    #error "You shouldn't use this header in strict ANSI C code"
#endif

#include <grp.h>

#if !(__POSIX__)

#   ifndef _P_TYPES_H_
#	include "p-types.h"	/* for gid_t. */
#   endif

extern struct group	*getgrnam __(( const char *_(username) ));
extern struct group	*getgrgid __(( _PI_LIBC_(gid_t) _(gid) ));

#endif /* !__POSIX__ */

#endif /* _P_GRP_H_ */

/*======================================================================*
 * $Log: p-grp.h,v $
 * Revision 1.2  1993/02/02  21:00:42  gerben
 * *** empty log message ***
 *
 * Revision 1.1  1993/01/28  15:20:12  tom
 * Initial revision
 *
 *======================================================================*/
