/*+++*
 *  RCS		$Id: p-utime.h,v 1.3 1993/02/02 21:00:42 gerben Exp $
 *  title:	p-utime.h
 *  abstract:	portable Posix-compliant <utime.h>.
 *  author:	T.R.Hageman, Groningen, The Netherlands
 *  created:	September 1992
 *  modified:	(see RCS Log at end)
 *  copyleft:
 *
 *		Copyright (C) 1992  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  description:
 *
 *	This is a Posix-compatible version of <utime.h> for both Posix
 *	and non-Posix systems.
 *
 *	Notes:
 *---*/

#ifndef _P_UTIME_H_
#define _P_UTIME_H_	0x102

#ifndef _PORTDEFS_H_ 
#   include "portdefs.h"
#endif

#if __STRICT_ANSI__
    #error "You shouldn't use this header in strict ANSI C code"
#endif

#ifndef _P_TIME_H_
#   include "p-time.h"			/* for time_t */
#endif

#if _I_UTIME
#   include <utime.h>
#endif


#if !(__POSIX__)

#   ifndef utimbuf			/* try to avoid name clashes. */
#	define utimbuf	_utimbuf

struct utimbuf {
	time_t	actime;
	time_t	modtime;
};
#   endif /* utimbuf */

#   if !_I_UTIME
#	if !__NO_PROTO__ && !__NO_TRIV_PROTO__
extern int	utime	__(( const char *_(path), struct utimbuf *_(times) ));
#	endif
#   endif

#endif /* !__POSIX__ */

#endif /* _P_UTIME_H_ */

/*======================================================================*
 * $Log: p-utime.h,v $
 * Revision 1.3  1993/02/02  21:00:42  gerben
 * *** empty log message ***
 *
 * Revision 1.2  1992/10/23  04:11:15  tom
 * add __STRICT_ANSI__ check; add __NO_TRIV_PROTO__.
 *
 * Revision 1.1  1992/10/14  13:57:18  tom
 * rename to "p-<header>".
 *
 * Revision 1.0  1992/10/08  23:57:57  tom
 * Initial revision
 *
 *======================================================================*/
