/* $Id: policy.ex,v 1.4 1993/02/02 21:00:00 gerben Exp $ */

/*
    Zend --- a mail transport program for large files and directories
    Copyright (C) 1992  Gerben C. Th. Wierda

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Gerben Wierda
    Goudriaanstraat 1
    1222 SG  Hilversum
    The Netherlands

    gerben@rna.indiv.nluug.nl
*/

/*
 *
 * policy.h -- directories and file names for zend.
 *
 */

#ifndef HOMEDIR
    You are out of luck! ....
#endif

/*
 * The mail program to use.
 * If /bin/mail is used it should
 *	- not generate a To: line by itself
 *	- accept remote addressees
 */
#define BINMAIL 1
#define USRUCBMAIL 0

/*
 * PATHBUFSIZ is the maximum length of a pathname (1024 on BSD systems)
 */
#define PATHBUFSIZ 1024

/*
 * FILENAMELENGTH is de maximum length of a filename (part of path).
 * 255 on BSD, 15 on SysV. Note that for directory transfers the way
 * tar behaves is essential.
 */
#define FILENAMELENGTH 255

/*
 * DUBLOCKSIZE is the size in bytes of the blocks reported by du -s
 */
#define DUBLOCKSIZE 1024

/*
 * Absolute program paths are used for minimum insecurity.
 * (since zend must run setuid root).
 */
#define CATPROG		"/bin/cat"
#define DUPROG		"/bin/du"
#define ECHOPROG	"/bin/echo"
#define RMPROG		"/bin/rm"
#define UUENCODEPROG	"/usr/bin/uuencode"
#define UUDECODEPROG	"/usr/bin/uudecode"
#define TARPROG		"/bin/tar"
#define COMPRESSPROG	"/usr/ucb/compress"
#define UNCOMPRESSPROG	"/usr/ucb/uncompress"
#define PWDPROG		"/bin/pwd"

/*======================================================================
 * $Log: policy.ex,v $
# Revision 1.4  1993/02/02  21:00:00  gerben
# *** empty log message ***
#
 * Revision 1.3  1993/01/10  23:48:06  tom
 * add some more *PROG configuration macros.
 *
 * Revision 1.2  1992/12/10  05:27:33  tom
 * add *PROG absolute program pathnames for setuid root security.
 *
 *======================================================================*/
